Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java	(revision 44198)
@@ -3183,94 +2446,92 @@
                 if (s < 0) {
                     s = 10;
                 }
-                return MessageFormat.format(config.getString(SQLConfig.type_bigdecimal), p,s);
+                return MessageFormat.format(type_bigdecimal, p, s);
             case DataTypes.FLOAT:
-                return MessageFormat.format(config.getString(SQLConfig.type_float), p,s);
+                return MessageFormat.format(type_float, p, s);
             case DataTypes.INT:
-                return MessageFormat.format(config.getString(SQLConfig.type_int), p,s);
+                return MessageFormat.format(type_int, p, s);
             case DataTypes.LONG:
-                return MessageFormat.format(config.getString(SQLConfig.type_long), p,s);
+                return MessageFormat.format(type_long, p, s);
             case DataTypes.STRING:
                 if (p < 0) {
-                    return config.getString(SQLConfig.type_string);
+                    return type_string;
                 } else if (p < 4096) {
-                    return MessageFormat.format(config.getString(SQLConfig.type_string_p),p);
+                    return MessageFormat.format(type_string_p, p);
                 }
-                return config.getString(SQLConfig.type_string);
+                return type_string;
             case DataTypes.TIME:
-                return config.getString(SQLConfig.type_time);
+                return type_time;
             case DataTypes.TIMESTAMP:
-                return config.getString(SQLConfig.type_timestamp);
+                return type_timestamp;
             case DataTypes.VERSION:
-                return config.getString(SQLConfig.type_version);
+                return type_version;
             case DataTypes.URI:
-                return config.getString(SQLConfig.type_URI);
+                return type_URI;
             case DataTypes.URL:
-                return config.getString(SQLConfig.type_URL);
+                return type_URL;
             case DataTypes.FILE:
-                return config.getString(SQLConfig.type_FILE);
+                return type_FILE;
             case DataTypes.FOLDER:
-                return config.getString(SQLConfig.type_FOLDER);
+                return type_FOLDER;
             default:
                 return null;
         }
     }
 
-    private static Map<Pair<Integer,Integer>,String> sqlgeometrytypes = null;
-    
     @Override
     public Object sqlgeometrytype(int type, int subtype) {
         // Devuelve un Object por que algunos gestores de BBDD utilizan
         // identificadores numericos para el tipo y otros strings.
         // Por defecto vamos a devolver strings.
-        if( sqlgeometrytypes==null ) {
+        if (sqlgeometrytypes == null) {
             sqlgeometrytypes = new HashMap<>();
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM2D), "POINT");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM3D), "POINTZ");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM2DM), "POINTM");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM3DM), "POINTZM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.POINT, Geometry.SUBTYPES.GEOM2D), "POINT");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.POINT, Geometry.SUBTYPES.GEOM3D), "POINTZ");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.POINT, Geometry.SUBTYPES.GEOM2DM), "POINTM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.POINT, Geometry.SUBTYPES.GEOM3DM), "POINTZM");
 
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM2D), "LINESTRING");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM3D), "LINESTRINGZ");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM2DM), "LINESTRINGM");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM3DM), "LINESTRINGZM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.LINE, Geometry.SUBTYPES.GEOM2D), "LINESTRING");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.LINE, Geometry.SUBTYPES.GEOM3D), "LINESTRINGZ");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.LINE, Geometry.SUBTYPES.GEOM2DM), "LINESTRINGM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.LINE, Geometry.SUBTYPES.GEOM3DM), "LINESTRINGZM");
 
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM2D), "POLYGON");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM3D), "POLYGONZ");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM2DM), "POLYGONM");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM3DM), "POLYGONZM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.POLYGON, Geometry.SUBTYPES.GEOM2D), "POLYGON");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.POLYGON, Geometry.SUBTYPES.GEOM3D), "POLYGONZ");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.POLYGON, Geometry.SUBTYPES.GEOM2DM), "POLYGONM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.POLYGON, Geometry.SUBTYPES.GEOM3DM), "POLYGONZM");
 
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM2D), "MULTIPOINT");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM3D), "MULTIPOINTZ");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM2DM), "MULTIPOINTM");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM3DM), "MULTIPOINTZM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTIPOINT, Geometry.SUBTYPES.GEOM2D), "MULTIPOINT");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTIPOINT, Geometry.SUBTYPES.GEOM3D), "MULTIPOINTZ");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTIPOINT, Geometry.SUBTYPES.GEOM2DM), "MULTIPOINTM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTIPOINT, Geometry.SUBTYPES.GEOM3DM), "MULTIPOINTZM");
 
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM2D), "MULTILINESTRING");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM3D), "MULTILINESTRINGZ");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM2DM), "MULTILINESTRINGM");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM3DM), "MULTILINESTRINGZM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTILINE, Geometry.SUBTYPES.GEOM2D), "MULTILINESTRING");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTILINE, Geometry.SUBTYPES.GEOM3D), "MULTILINESTRINGZ");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTILINE, Geometry.SUBTYPES.GEOM2DM), "MULTILINESTRINGM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTILINE, Geometry.SUBTYPES.GEOM3DM), "MULTILINESTRINGZM");
 
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTICURVE,Geometry.SUBTYPES.GEOM2D), "MULTILINESTRING");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTICURVE,Geometry.SUBTYPES.GEOM3D), "MULTILINESTRINGZ");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTICURVE,Geometry.SUBTYPES.GEOM2DM), "MULTILINESTRINGM");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTICURVE,Geometry.SUBTYPES.GEOM3DM), "MULTILINESTRINGZM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTICURVE, Geometry.SUBTYPES.GEOM2D), "MULTILINESTRING");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTICURVE, Geometry.SUBTYPES.GEOM3D), "MULTILINESTRINGZ");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTICURVE, Geometry.SUBTYPES.GEOM2DM), "MULTILINESTRINGM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTICURVE, Geometry.SUBTYPES.GEOM3DM), "MULTILINESTRINGZM");
 
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM2D), "MULTIPOLYGON");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM3D), "MULTIPOLYGONZ");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM2DM), "MULTIPOLYGONM");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM3DM), "MULTIPOLYGONZM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON, Geometry.SUBTYPES.GEOM2D), "MULTIPOLYGON");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON, Geometry.SUBTYPES.GEOM3D), "MULTIPOLYGONZ");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON, Geometry.SUBTYPES.GEOM2DM), "MULTIPOLYGONM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON, Geometry.SUBTYPES.GEOM3DM), "MULTIPOLYGONZM");
 
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTISURFACE,Geometry.SUBTYPES.GEOM2D), "MULTIPOLYGON");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTISURFACE,Geometry.SUBTYPES.GEOM3D), "MULTIPOLYGONZ");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTISURFACE,Geometry.SUBTYPES.GEOM2DM), "MULTIPOLYGONM");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTISURFACE,Geometry.SUBTYPES.GEOM3DM), "MULTIPOLYGONZM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTISURFACE, Geometry.SUBTYPES.GEOM2D), "MULTIPOLYGON");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTISURFACE, Geometry.SUBTYPES.GEOM3D), "MULTIPOLYGONZ");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTISURFACE, Geometry.SUBTYPES.GEOM2DM), "MULTIPOLYGONM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.MULTISURFACE, Geometry.SUBTYPES.GEOM3DM), "MULTIPOLYGONZM");
 
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM2D), "GEOMETRY");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM3D), "GEOMETRYZ");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM2DM), "GEOMETRYM");
-            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM3DM), "GEOMETRYZM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.GEOMETRY, Geometry.SUBTYPES.GEOM2D), "GEOMETRY");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.GEOMETRY, Geometry.SUBTYPES.GEOM3D), "GEOMETRYZ");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.GEOMETRY, Geometry.SUBTYPES.GEOM2DM), "GEOMETRYM");
+            sqlgeometrytypes.put(new ImmutablePair<>(Geometry.TYPES.GEOMETRY, Geometry.SUBTYPES.GEOM3DM), "GEOMETRYZM");
         }
-        return sqlgeometrytypes.get(new ImmutablePair<>(type,subtype));
+        return sqlgeometrytypes.get(new ImmutablePair<>(type, subtype));
     }
 
     @Override
@@ -3278,7 +2539,7 @@
         // Devuelve un Object por que algunos gestortes de BBDD utilizan
         // identificadores numericos para las dimensiones y otros strings.
         // Por defecto vamos a devolver enteros.
-        switch(subtype) {
+        switch (subtype) {
             case Geometry.SUBTYPES.GEOM3D:
                 return 3;
             case Geometry.SUBTYPES.GEOM2DM:
@@ -3290,23 +2551,23 @@
                 return 2;
         }
     }
-    
+
     protected TableNameBuilder createTableNameBuilder() {
         return new TableNameBuilderBase();
     }
-    
+
     protected SelectColumnBuilder createSelectColumnBuilder() {
         return new SelectColumnBuilderBase();
     }
-    
+
     protected UpdateColumnBuilder createUpdateColumnBuilder() {
         return new UpdateColumnBuilderBase();
     }
-    
+
     protected InsertColumnBuilder createInsertColumnBuilder() {
         return new InsertColumnBuilderBase();
     }
-    
+
     protected OrderByBuilder createOrderByBuilder() {
         return new OrderByBuilderBase();
     }
@@ -3334,7 +2595,7 @@
     protected GrantRoleBuilder createGrantRoleBuilder(TableNameBuilder table, String role) {
         return new GrantRoleBuilderBase(table, role);
     }
-    
+
     protected DropTableBuilder createDropTableBuilder() {
         return new DropTableBuilderBase();
     }
@@ -3358,7 +2619,7 @@
     protected CreateIndexBuilder createCreateIndexBuilder() {
         return new CreateIndexBuilderBase();
     }
-    
+
     @Override
     public SelectBuilder select() {
         if (this.select == null) {
@@ -3399,7 +2660,6 @@
         return this.create_index;
     }
 
-    
     @Override
     public DeleteBuilder delete() {
         if (this.delete == null) {
@@ -3440,7 +2700,6 @@
         return this.grant;
     }
 
-    @Override
     public void accept(Visitor visitor, VisitorFilter filter) {
         if (this.select != null) {
             this.select.accept(visitor, filter);
@@ -3463,334 +2722,110 @@
         if (this.drop_table != null) {
             this.drop_table.accept(visitor, filter);
         }
-//        if( this.value == null) {
-//            return;
-//        }
-//        this.value.accept(visitor, filter);
     }
 
-    
+    protected Formatter formatter() {
+        return ExpressionBuilder.EMPTY_FORMATTER;
+    }
+
     @Override
     public String toString() {
+        return this.toString(formatter());
+    }
+
+    @Override
+    public String toString(Formatter formatter) {
         if (this.select != null) {
-            return this.select.toString();
+            return this.select.toString(formatter);
         }
         if (this.update != null) {
-            return this.update.toString();
+            return this.update.toString(formatter);
         }
         if (this.insert != null) {
-            return this.insert.toString();
+            return this.insert.toString(formatter);
         }
         if (this.delete != null) {
-            return this.delete.toString();
+            return this.delete.toString(formatter);
         }
         if (this.alter_table != null) {
-            return this.alter_table.toString();
+            return this.alter_table.toString(formatter);
         }
         if (this.create_table != null) {
-            return this.create_table.toString();
+            return this.create_table.toString(formatter);
         }
         if (this.drop_table != null) {
-            return this.drop_table.toString();
+            return this.drop_table.toString(formatter);
         }
         if (this.update_table_statistics != null) {
-            return this.update_table_statistics.toString();
+            return this.update_table_statistics.toString(formatter);
         }
-        if ( this.value != null ) {
-            return this.value.toString();
-        }
-        return ""; 
+        return "";
     }
 
     @Override
-    public Function ST_UnionAggregate(Value geom) {
-        return builtin_function("ST_UnionAggregate", config.getString(SQLConfig.ST_UnionAggregate), geom);
+    public CountBuilder count() {
+        return new CountBuilderBase();
     }
 
     @Override
-    public Function ST_ExtentAggregate(Value geom) {
-        return builtin_function("ST_ExtentAggregate", config.getString(SQLConfig.ST_ExtentAggregate), geom);
+    public List<Parameter> parameters() {
+        final List<Parameter> params = new ArrayList<>();
+        this.accept(new Visitor() {
+            @Override
+            public void visit(Visitable value) {
+                params.add((Parameter) value);
+            }
+        }, new ClassVisitorFilter(Parameter.class));
+        return params;
     }
 
     @Override
-    public CountBuilder count() {
-        return new CountBuilderBase();
+    public List<Variable> variables() {
+        final List<Variable> vars = new ArrayList<>();
+        this.accept(new Visitor() {
+            @Override
+            public void visit(Visitable value) {
+                if (!vars.contains((Variable) value)) {
+                    vars.add((Variable) value);
+                }
+            }
+        }, new ClassVisitorFilter(Variable.class));
+        return vars;
     }
 
     @Override
-    public Column column(FeatureAttributeDescriptor fad) {
-        ColumnDescriptorBase descriptor;
-        if( fad.getType()==org.gvsig.fmap.geom.DataTypes.GEOMETRY ) {
-            descriptor = new ColumnDescriptorBase(
-                    fad.getName(),
-                    fad.getGeomType().getType(),
-                    fad.getGeomType().getSubType(),
-                    fad.getSRS(),
-                    fad.isIndexed(),
-                    fad.allowNull()
-            );
-        } else {
-            descriptor = new ColumnDescriptorBase(
-                    fad.getName(),
-                    fad.getType(),
-                    fad.getSize(),
-                    fad.getPrecision(),
-                    fad.isPrimaryKey(),
-                    fad.isIndexed(),
-                    fad.allowNull(),
-                    fad.isAutomatic(),
-                    fad.getDefaultValue()
-            );
+    public List<String> parameters_names() {
+        List<String> params = new ArrayList<>();
+        for (Parameter param : parameters()) {
+            String s;
+            switch (param.type()) {
+                case Constant:
+                    Object theValue = param.value();
+                    if (theValue == null) {
+                        s = "null";
+                    } else if (theValue instanceof String) {
+                        s = "'" + (String) theValue + "'";
+                    } else {
+                        s = theValue.toString();
+                    }
+                    break;
+                case Geometry:
+                case Variable:
+                default:
+                    s = "\"" + param.name() + "\"";
+            }
+            params.add(s);
         }
-        FeatureStore store = fad.getStore();
-        if( store!=null ) {
-            descriptor.setStoreParameters(store.getParameters());
-        }
-        return new VariableBase(descriptor);
+        return params;
     }
-    
-    @Override
-    public Function Find_SRID(Value schema, Value table, Value column) {
-        return builtin_function("Find_SRID", config.getString(SQLConfig.Find_SRID), schema, table, column);
-    }
 
-
-    public Function iif(Value condition, Value iftrue, Value iffalse) {
-        return builtin_function("IIF", config.getString(Config.iif), condition, iftrue, iffalse);
-    }
-
-    public Function ifnull(Value value, Value iftrue, Value iffalse) {
-        return builtin_function("IFNULL", config.getString(Config.ifnull), value, iftrue, iffalse);
-    }
-    
-    
     @Override
-    public Function left(Value str, Value size) {
-       return function("left", str, size);
-       // return builtin_function("left", "left({1})",str,size);
+    public List<String> variables_names() {
+        List<String> vars = new ArrayList<>();
+        for (Variable var : this.variables()) {
+            vars.add(var.name());
+        }
+        Collections.sort(vars);
+        return vars;
     }
-    
-    @Override
-    public Function right(Value str, Value len) {
-       return function("right", str, len);
-    }
-    
-    @Override
-    public Function locate(Value search, Value str, Value start) {
-       return function("locate", search, str, start);
-    }
-    
-    @Override
-    public Function position(Value search, Value str) {
-       return function("position", search, str);
-    }
-    
-    @Override
-    public Function lpad(Value str, Value len, Value padstr) {
-       return function("lpad", str, len, padstr);
-    }
-    
-    @Override
-    public Function rpad(Value str, Value len, Value padstr) {
-       return function("rpad", str, len, padstr);
-    }
-    
-    @Override
-    public Function ltrim(Value str) {
-       return function("ltrim", str);
-    }
-    
-    @Override
-    public Function rtrim(Value str) {
-       return function("rtrim", str);
-    }
-    
-    @Override
-    public Function trim(Value str) {
-       return function("trim", str);
-    }
-    
-    @Override
-    public Function repeat(Value str, Value size) {
-       return function("repeat", str, size);
-    }
-    
-    @Override
-    public Function replace(Value str, Value search, Value replstr) {
-       return function("replace", str, search, replstr);
-    }
-    
-    @Override
-    public Function ascii(Value str) {
-       return function("ascii", str);
-    }
-    
-    @Override
-    public Function lenght(Value str) {
-       return function("lenght", str);
-    }
-
-    @Override
-    public Function instr(Value str, Value search, Value start) {
-       return function("instr", str, search, start);
-    }
-    
-    @Override
-    public Function lower(Value str) {
-       return function("lower", str);
-    }
-    
-    @Override
-    public Function upper(Value str) {
-       return function("upper", str);
-    }
-    
-    @Override
-    public Function space(Value size) {
-       return function("space", size);
-    }
-    
-    @Override
-    public Function substring(Value str, Value start, Value len) {
-       return function("substring", str, start, len);
-    }
-    
-    @Override
-    public Function acos(Value num) {
-       return function("acos", num);
-    } 
-    
-    @Override
-    public Function asin(Value num) {
-       return function("asin", num);
-    }
-    
-    @Override
-    public Function atan(Value num) {
-       return function("atan", num);
-    }
-    
-    @Override
-    public Function cos(Value num) {
-       return function("cos", num);
-    }
-    
-    @Override
-    public Function cosh(Value num) {
-       return function("cosh", num);
-    }
-    
-    @Override
-    public Function cot(Value num) {
-       return function("cot", num);
-    }  
-    
-    @Override
-    public Function bitand(Value num1, Value num2) {
-       return function("bitand", num1, num2);
-    } 
-    
-    @Override
-    public Function bitor(Value num1, Value num2) {
-       return function("bitor", num1, num2);
-    }
-    
-    @Override
-    public Function bitxor(Value num1, Value num2) {
-       return function("bitxor", num1, num2);
-    }
-    
-    @Override
-    public Function ceil(Value num) {
-       return function("ceil", num);
-    }
-    
-    @Override
-    public Function degrees(Value num) {
-       return function("degrees", num);
-    }  
-    
-    @Override
-    public Function exp(Value num) {
-       return function("exp", num);
-    }  
-    
-    @Override
-    public Function floor(Value num) {
-       return function("floor", num);
-    }  
-    
-    @Override
-    public Function log(Value num) {
-       return function("log", num);
-    }  
-    
-    @Override
-    public Function log10(Value num) {
-       return function("log10", num);
-    }  
-    
-    @Override
-    public Function pi(Value num) {
-       return function("pi", num);
-    }
-    
-    @Override
-    public Function power(Value num) {
-       return function("power", num);
-    }
-    
-    @Override
-    public Function radians(Value num) {
-       return function("radians", num);
-    }
-    
-    @Override
-    public Function rand(Value num) {
-       return function("rand", num);
-    }
-    
-    @Override
-    public Function round(Value num) {
-       return function("round", num);
-    }
-    
-    @Override
-    public Function sqrt(Value num) {
-       return function("sqrt", num);
-    }
-    
-    @Override
-    public Function sign(Value num) {
-       return function("sign", num);
-    }
-    
-    @Override
-    public Function sin(Value num) {
-       return function("sin", num);
-    }
-    
-    @Override
-    public Function sinh(Value num) {
-       return function("sinh", num);
-    }
-    
-    @Override
-    public Function tan(Value num) {
-       return function("tan", num);
-    }
-    @Override
-    public Function tanh(Value num) {
-       return function("cosh", num);
-    }  
-    
-    @Override
-    public Function zero() {
-       return function("zero");
-    }
-    
-    @Override
-    public Function chr(Value num) {
-       return function("chr", num);
-    }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/AbstractFeatureStoreProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/AbstractFeatureStoreProvider.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/AbstractFeatureStoreProvider.java	(revision 44198)
@@ -33,6 +33,7 @@
 import org.cresques.cts.ICRSFactory;
 import org.cresques.cts.IProjection;
 import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
@@ -562,7 +563,8 @@
 
     @Override
     public ExpressionBuilder createExpression() {
-        return new SQLBuilderBase();
+        ExpressionBuilder builder = ExpressionEvaluatorLocator.getManager().createExpressionBuilder();
+        return builder;
     }
 
     protected void savePrjFile(File dataFile, IProjection proj){
